routes/web.php
<?php

use App\Services\CodeService;

Auth::routes();

Route::middleware('auth')->group(function () {

    Route::get('/', 'HomeController@index')->name('home');
    Route::get('/profile', 'HomeController@index')->name('profile');
    Route::resource('codes', 'CodeController')->except(['show']);
    Route::resource('users', 'UserController')->except(['show']);

    Route::get('/codes/reset', function(CodeService $codeService) {
        $codeService->resetSerialNumbers();
        return redirect(route('codes.index'));
    })->name('codes.reset');

});

app/Code.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Code extends Model
{
    /**
     * The table schema.
     */

    const TABLE_NAME = 'codes';

    const FIELD_PK = 'id';
    const FIELD_CAR_ID = 'car_id';
    const FIELD_SERIAL_NUMBER = 'serial_number';
    const FIELD_CODE = 'code';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        self::FIELD_CAR_ID,
        self::FIELD_SERIAL_NUMBER,
        self::FIELD_CODE,
    ];

    /*
	|--------------------------------------------------------------------------
	| Getters
	|--------------------------------------------------------------------------
    */

    /**
     * Get the user id.
     *
     * @return int
     */
    public function getId()
    {
        return (int) $this->getAttribute(static::FIELD_PK);
    }

    /**
     * Get the car id.
     *
     * @return int
     */
    public function getCarId()
    {
        return (int) $this->getAttribute(static::FIELD_CAR_ID);
    }

    /**
     * Get the serial number.
     *
     * @return int
     */
    public function getSerialNumber() : int
    {
        return $this->getAttribute(static::FIELD_SERIAL_NUMBER);
    }

    /**
     * Get the code.
     *
     * @return int
     */
    public function getCode()
    {
        return (int) $this->getAttribute(static::FIELD_CODE);
    }

    /*
	|--------------------------------------------------------------------------
	| Setters
	|--------------------------------------------------------------------------
    */

    /**
     * Set the car id.
     *
     * @param int $id
     */
    public function setCarId(int $id)
    {
        $this->setAttribute(static::FIELD_CAR_ID, $id);
    }

    /**
     * Set the serial number.
     *
     * @param int $n
     */
    public function setSerialNumber(int $n)
    {
        $this->setAttribute(static::FIELD_SERIAL_NUMBER, $n);
    }

    /**
     * Set the code.
     *
     * @param int $code
     */
    public function setCode(int $code)
    {
        $this->setAttribute(static::FIELD_CODE, $code);
    }

    /*
	|--------------------------------------------------------------------------
	| Relationships
	|--------------------------------------------------------------------------
    */

    /**
     * The car that the code belongs to
     *
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function car()
    {
        return $this->belongsTo(Car::class)->withDefault([
            Car::FIELD_PK => null,
            Car::FIELD_MANUFACTURER => null,
            Car::FIELD_PLATE_NUMBER => null,
            Car::FIELD_MODEL => null,
            Car::FIELD_MODEL_YEAR => null,
            Car::FIELD_DRIVER_ID => null,
        ]);
    }
}

app/Http/Controllers/CodeController.php
<?php

namespace App\Http\Controllers;

use App\Cache\CodeCache;
use App\Http\Requests\CodeRequest;
use App\Repositories\CodeRepository;
use App\Services\CodeService;
use Illuminate\Database\Eloquent\ModelNotFoundException;

class CodeController extends Controller
{
    /**
     * @var CodeRepository
     */
    private $codeRepository;

    /**
     * @var CodeService
     */
    private $codeService;

    /**
     * @var CodeCache
     */
    private $codeCache;

    /**
     * CodeController constructor.
     *
     * @param CodeService $codeService
     * @param CodeRepository $codeRepository
     */
    public function __construct(CodeService $codeService, CodeRepository $codeRepository)
    {
        set_search_action(route('codes.index'));

        $this->codeService = $codeService;
        $this->codeRepository = $codeRepository;
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        set_title(trans('nav.codes'));

        $searchQuery = request(KEYWORD_SEARCH_QUERY);

        if ($searchQuery) {
            $codes = $this->codeService->search($searchQuery);
        } else {
            $codes = $this->codeService->all();
        }

        return view('codes.index')->with(compact('codes', 'searchQuery'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        set_title(trans('codes.create_code'));

        $serialNumber = $this->codeService->countAll() + 1;

        return view('codes.create-edit', compact('serialNumber'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param CodeRequest $request
     * @return \Illuminate\Http\Response
     */
    public function store(CodeRequest $request)
    {
        try {

            if ($this->codeService->create(
                request('driver_name'),
                request('driver_phone_number'),
                request('car_plate_number'),
                request('car_manufacturer'),
                request('car_model'),
                request('car_model_year'),
                request('serial_number'),
                request('car_code')
            )) {
                return redirect_success(route('codes.index'), trans('codes.create_success'));
            }

            return redirect_fail(route('codes.create'), trans('codes.create_fail'));

        } catch (\Exception $exception) {
            return redirect_fail(route('codes.create'), trans('misc.database_exception'));
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        set_title(trans('codes.edit_code'));

        enable_edit_mode();

        try {

            $this->codeRepository->setRelations([
                'car.driver',
            ]);

            $code = $this->codeRepository->find($id);

            $serialNumber = optional(@$code)->getSerialNumber();

            return view('codes.create-edit')->with(compact('code', 'serialNumber'));

        } catch (ModelNotFoundException $exception) {
            return redirect_fail(route('codes.create'), trans('codes.code_not_found'));
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param CodeRequest $request
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function update(CodeRequest $request, $id)
    {
        try {

            if ($this->codeService->update(
                $id,
                request('driver_name'),
                request('driver_phone_number'),
                request('car_plate_number'),
                request('car_manufacturer'),
                request('car_model'),
                request('car_model_year'),
                request('serial_number'),
                request('car_code')
            )) {
                return redirect_success(route('codes.index'), trans('codes.update_success'));
            }

            return redirect_fail(route('codes.update', $id), trans('codes.update_fail'));

        } catch (\Exception $exception) {
            return redirect_fail(route('codes.update', $id), trans('misc.database_exception'));
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        try {

            if ($this->codeService->delete($id)) {
                return redirect_success(route('codes.index'), trans('codes.delete_success'));
            }

            return redirect_fail(route('codes.index'), trans('codes.delete_fail'));

        } catch (\Exception $exception) {
            return redirect_fail(route('codes.index'), trans('misc.database_exception'));
        }
    }
}

resources/views/codes/create-edit.blade.php
@extends('layouts.app')

@section('content')

    <div class="row">
        <div class="col-md-8 col-md-offset-2">

            <div class="card-box">

                @empty ($editMode)
                <form action="{{ route('codes.store') }}" method="post">
                @else
                <form action="{{ route('codes.update', $code->getId()) }}" method="post">
                    {!! method_field('PUT') !!}
                @endif
                    {!! csrf_field() !!}

                    <div class="form-group{{ $errors->has('serial_number') ? ' has-error' : '' }}">
                        <label for="serial_number" class="form-label">@lang('codes.serial_number')</label>
                        <input autofocus type="number" required="" id="serial_number" name="serial_number" class="form-control" value="{{ old('serial_number', $serialNumber) }}">
                        @if ($errors->has('serial_number'))
                            <span class="help-block">
                            <strong>{{ $errors->first('serial_number') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <div class="form-group{{ $errors->has('driver_name') ? ' has-error' : '' }}">
                        <label for="driver_name" class="form-label">@lang('codes.driver_name')</label>
                        <input type="text" required="" id="driver_name" name="driver_name" class="form-control" value="{{ old('driver_name', optional(optional(@$code->car)->driver)->getName()) }}">
                        @if ($errors->has('driver_name'))
                            <span class="help-block">
                            <strong>{{ $errors->first('driver_name') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <div class="form-group{{ $errors->has('car_plate_number') ? ' has-error' : '' }}">
                        <label for="car_plate_number" class="form-label">@lang('codes.car_plate_number')</label>
                        <input required type="text" id="car_plate_number" name="car_plate_number" class="form-control" value="{{ old('car_plate_number', optional(@$code->car)->getPlateNumber()) }}">
                        @if ($errors->has('car_plate_number'))
                            <span class="help-block">
                            <strong>{{ $errors->first('car_plate_number') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <div class="form-group{{ $errors->has('car_code') ? ' has-error' : '' }}">
                        <label for="car_code" class="form-label">@lang('codes.car_code')</label>
                        <input required type="number" min="0" max="9999999" id="car_code" name="car_code" class="form-control" value="{{ old('car_code', optional(@$code)->getCode()) }}">
                        @if ($errors->has('car_code'))
                            <span class="help-block">
                            <strong>{{ $errors->first('car_code') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <div class="form-group{{ $errors->has('driver_phone_number') ? ' has-error' : '' }}">
                        <label for="driver_phone_number" class="form-label">@lang('codes.driver_phone_number')</label>
                        <input type="text" id="driver_phone_number" name="driver_phone_number" class="form-control" value="{{ old('driver_phone_number', optional(optional(@$code->car)->driver)->getPhoneNumber()) }}">
                        @if ($errors->has('driver_phone_number'))
                            <span class="help-block">
                            <strong>{{ $errors->first('driver_phone_number') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <div class="form-group{{ $errors->has('car_manufacturer') ? ' has-error' : '' }}">
                        <label for="car_manufacturer" class="form-label">@lang('codes.car_manufacturer')</label>
                        <input type="text" id="car_manufacturer" name="car_manufacturer" class="form-control" value="{{ old('car_manufacturer', optional(@$code->car)->getManufacturer()) }}">
                        @if ($errors->has('car_manufacturer'))
                            <span class="help-block">
                            <strong>{{ $errors->first('car_manufacturer') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <div class="form-group{{ $errors->has('car_model') ? ' has-error' : '' }}">
                        <label for="car_model" class="form-label">@lang('codes.car_model')</label>
                        <input type="text" id="car_model" name="car_model" class="form-control" value="{{ old('car_model', optional(@$code->car)->getModel()) }}">
                        @if ($errors->has('car_model'))
                            <span class="help-block">
                            <strong>{{ $errors->first('car_model') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <div class="form-group{{ $errors->has('car_model_year') ? ' has-error' : '' }}">
                        <label for="car_model_year" class="form-label">@lang('codes.car_model_year')</label>
                        <input type="text" id="car_model_year" name="car_model_year" class="form-control" value="{{ old('car_model_year', optional(@$code->car)->getModelYear()) }}">
                        @if ($errors->has('car_model_year'))
                            <span class="help-block">
                            <strong>{{ $errors->first('car_model_year') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <input type="hidden" name="code_id" value="{{ optional(@$code)->getId() }}">
                    <input type="hidden" name="car_id" value="{{ optional(optional(@$code->car))->getId() }}">

                    <button type="submit" class="btn btn-primary" name="submit">
                        @isset($editMode)
                        <i class="fa fa-pencil"></i> @lang('misc.edit')
                        @else
                        <i class="fa fa-plus-circle"></i> @lang('misc.add')
                        @endif
                    </button>
                    <button type="reset" class="btn btn-default">
                        <i class="fa fa-fw fa-refresh"></i> @lang('misc.reset')
                    </button>

                </form>
            </div><!-- /.card-box -->

        </div><!-- /.col -->
    </div><!-- /.row -->

@endsection

resources/views/codes/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="m-b-25">
        <a href="{{ route('codes.create') }}" class="btn btn-primary waves-effect">
            <i class="fa fa-fw fa-plus-circle"></i> @lang('codes.create_code')
        </a>
        <a href="{{ route('codes.reset') }}" class="btn btn-inverse waves-effect">
            <i class="fa fa-fw fa-plus-circle"></i> @lang('codes.reset_serial_numbers')
        </a>
    </div>

    @if ($searchQuery)
    <div class="alert alert-info">@lang('codes.search_alert_text', ['query' => $searchQuery, 'link' => route('codes.index')])</div>
    @endif

    <div class="card-box">
        <table class="table table-striped table-responsive m-b-0">
            <thead>
                <tr>
                    <th class="text-center" style="width: 1%">#</th>
                    <th>@lang('codes.driver_name')</th>
                    <th class="text-center">@lang('codes.car_plate_number')</th>
                    <th class="text-center">@lang('codes.car_code')</th>
                    <th class="text-center">@lang('codes.car_info')</th>
                    <th class="text-left" style="width: 25%">@lang('misc.controls')</th>
                </tr>
            </thead>
            <tbody>
                @each('codes.table-row', $codes, 'code', 'codes.table-empty')
            </tbody>
        </table>
    </div>

    <div class="text-center">
        {{ $codes->appends(['q' => $searchQuery])->links() }}
    </div>

@endsection

resources/views/codes/table-empty.blade.php
<tr>
    <td colspan="6" class="text-center">@lang('codes.no_codes')</td>
</tr>

resources/views/codes/table-row-controls.blade.php
<div class="btn-group">
    <form action="{{ route('codes.destroy', $code->getId()) }}" method="post" class="form-inline">
        {{ csrf_field() }}
        {{ method_field('DELETE') }}
        <a href="{{ route('codes.edit', $code->getId()) }}" class="btn btn-default btn-sm waves-effect" title="@lang('misc.edit')">
            <i class="fa fa-fw fa-pencil-square-o"></i>
        </a>
        <button type="submit" class="btn btn-default btn-sm waves-effect waves-danger delete-btn"><i class="fa fa-fw fa-trash-o"></i></button>
    </form>
</div>

resources/views/codes/table-row.blade.php
<tr>
    <th class="text-center" style="width: 1%" scope="row">{{ $code->getSerialNumber() }}</th>
    <td>{{ $code->car->driver->getName() }}</td>
    <td class="text-center">
        <span class="badge badge-default">{{ $code->car->getPlateNumber() }}</span>
    </td>
    <td class="text-center">
        <span class="badge badge-default">{{ $code->getCode() }}</span>
    </td>
    <td class="text-center">
        {{ $code->car->getManufacturer() ?: trans('misc.unknown') }}
        <span>
            @if ($code->car->getModel())
                {{ $code->car->getModel() }}
            @endif
            @if ($code->car->getModelYear())
                {{ $code->car->getModelYear() }}
            @endif
        </span>
    </td>
    <td class="text-left">
        @include('codes.table-row-controls', ['code' => $code])
    </td>
</tr>